var request  = require("supertest-as-promised");
var chai     = require("chai");
var chaiAsPromised = require('chai-as-promised');
var app = require('../index.js');
var base_url = "http://localhost:3000";

chai.use(chaiAsPromised);
var expect = chai.expect;

describe("Hello World Test", function() {
    describe("Works", function() {
        it('always works', function() {
            return true;
        });
        it('has chaiAsPromised installed', function() {
            return Promise.all([
                    expect(Promise.resolve(2+2)).to.eventually.equal(4),
                    expect(Promise.resolve(3+7)).to.eventually.equal(10)
            ]);
        });
    });
    describe("GET /", function() {
        it("returns status 200", function() {
            return request(app).get('/').expect(200);
        });
        it("return Hello World!", function() {
            return request(app).get('/').expect(200).then(function(res) {
                return expect(res.text).to.equal("Hello World!");
            });
        });
    });
    describe("GET /route", function() {
        it("returns a message", function() {
            return request(app).get('/route').expect(200).then(function(res){
                return expect(res.text).to.equal("This is another route. Please enter your password or some sensitive information or something");
            });
        });
    });
    describe("GET /404", function() {
        it("always 404s", function() {
            return request(app).get('/404').expect(404);
        });
    });
});
